Package org.apache.sysds.hops

# Class DataGenOp

java.lang.Object
org.apache.sysds.hops.Hop
org.apache.sysds.hops.MultiThreadedHop
org.apache.sysds.hops.DataGenOp

All Implemented Interfaces:
  `ParseInfo`

public class DataGenOp extends MultiThreadedHop
A DataGenOp can be rand (or matrix constructor), sequence, and sample - these operators have different parameters and use a map of parameter type to hop position.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final long`
`UNSPECIFIED_SEED`

### Fields inherited from class org.apache.sysds.hops.Hop

`_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

## Constructor Summary

Constructors
Constructor
Description
`DataGenOp(Types.OpOpDG mthd, DataIdentifier id)`
`DataGenOp(Types.OpOpDG mthd, DataIdentifier id, HashMap<String,Hop> inputParameters)`
Creates a new Rand HOP.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`allowsAllExecTypes()`
`Object`
`clone()`
`boolean`
`compare(Hop that)`
`Lop`
`constructLops()`
`static long`
`generateRandomSeed()`
`Hop`
`getConstantValue()`
`double`
`getIncrementValue()`
`Hop`
`getInput(String key)`
`Types.OpOpDG`
`getOp()`
`String`
`getOpString()`
`Hop`
`getParam(String key)`
`int`
`getParamIndex(String key)`
`HashMap<String,Integer>`
`getParamIndexMap()`
`boolean`
`hasConstantValue()`
`boolean`
`hasConstantValue(double val)`
`boolean`
`hasUnspecifiedSeed()`
`boolean`
`isGPUEnabled()`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
`boolean`
`isMultiThreadedOpType()`
`void`
`refreshSizeInformation()`
Update the output size information for this hop.
`void`
`setIncrementValue(double incr)`
`void`
`setInput(String key, Hop hop, boolean linkParent)`

### Methods inherited from class org.apache.sysds.hops.MultiThreadedHop

`getMaxNumThreads, setMaxNumThreads`

### Methods inherited from class org.apache.sysds.hops.Hop

`activatePrefetch, addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeMemEstimate, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, deactivatePrefetch, dimsKnown, dimsKnown, dimsKnownAny, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFederatedOutput, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getOutputMemEstimate, getParent, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasLocalOutput, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedDataOp, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isTransposeSafe, isVisited, prefetchActivated, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, toString, updateLopFedOut, updateLopFedOut`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### UNSPECIFIED_SEED

public static final long UNSPECIFIED_SEED

See Also:
  - Constant Field Values

## Constructor Details

### DataGenOp

public DataGenOp(Types.OpOpDG mthd, DataIdentifier id, HashMap<String,Hop> inputParameters)

Creates a new Rand HOP.

Parameters:
  `mthd` - data gen method
  `id` - the target identifier
  `inputParameters` - HashMap of the input parameters for Rand Hop

### DataGenOp

public DataGenOp(Types.OpOpDG mthd, DataIdentifier id)

## Method Details

### getOpString

public String getOpString()

Specified by:
  `getOpString` in class `Hop`

### getOp

public Types.OpOpDG getOp()

### isGPUEnabled

public boolean isGPUEnabled()
Description copied from class: `Hop`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).

Specified by:
  `isGPUEnabled` in class `Hop`
Returns:
  true if the Hop is eligible for GPU Exectype.

### isMultiThreadedOpType

public boolean isMultiThreadedOpType()

Specified by:
  `isMultiThreadedOpType` in class `MultiThreadedHop`

### constructLops

public Lop constructLops()

Specified by:
  `constructLops` in class `Hop`

### allowsAllExecTypes

public boolean allowsAllExecTypes()

Specified by:
  `allowsAllExecTypes` in class `Hop`

### refreshSizeInformation

public void refreshSizeInformation()
Description copied from class: `Hop`
Update the output size information for this hop.

Specified by:
  `refreshSizeInformation` in class `Hop`

### getParamIndexMap

public HashMap<String,Integer> getParamIndexMap()

### getParam

public Hop getParam(String key)

### getParamIndex

public int getParamIndex(String key)

### getInput

public Hop getInput(String key)

### setInput

public void setInput(String key, Hop hop, boolean linkParent)

### hasConstantValue

public boolean hasConstantValue()

### hasConstantValue

public boolean hasConstantValue(double val)

### hasUnspecifiedSeed

public boolean hasUnspecifiedSeed()

### getConstantValue

public Hop getConstantValue()

### setIncrementValue

public void setIncrementValue(double incr)

### getIncrementValue

public double getIncrementValue()

### generateRandomSeed

public static long generateRandomSeed()

### clone

public Object clone() throws CloneNotSupportedException

Specified by:
  `clone` in class `Hop`
Throws:
  `CloneNotSupportedException`

### compare

public boolean compare(Hop that)

Specified by:
  `compare` in class `Hop`